"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var curry2_1 = require("./curry2");
function curry3(fn) {
    function curried(a, b, c) {
        var args = [];
        for (var _i = 3; _i < arguments.length; _i++) {
            args[_i - 3] = arguments[_i];
        }
        switch (arguments.length) {
            case 1:
                return curry2_1.curry2(function (b, c) { return fn(a, b, c); });
            case 2:
                return function (c) {
                    var args = [];
                    for (var _i = 1; _i < arguments.length; _i++) {
                        args[_i - 1] = arguments[_i];
                    }
                    return fn.apply(void 0, [a, b, c].concat(args));
                };
            default:
                return fn.apply(void 0, [a, b, c].concat(args));
        }
    }
    return curried;
}
exports.curry3 = curry3;
//# sourceMappingURL=curry3.js.map